% analogy version
% Experiment 1: predictive inference
% BGGPE positive condition
% Background cause: B
% Generative cause 1: G1
% Generative cause 2: G2
% Preventive cause 1: P1
% 6/1/10 by Hee Seung Lee

clear all;
syms w0 w1 w2 w3;

% Predictive Inference 
% When a source has B(w0), G1(w1), G2(w2), and P1(w3)

%normalizing term in the source BGGP
%positive condition: source has the effect
eqSC = (1-(1-w0)*(1-w1)*(1-w2))*(1-w3);
normterm = int(int(int(int(eqSC, w0,0,1), w1,0,1),w2,0,1),w3,0,1);

%target: No-drop: BGGP condition
eqTG = (1-(1-w0)*(1-w1)*(1-w2))*(1-w3);
eq2 = eqSC*eqTG;
ggp = int(int(int(int(eq2, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_ggp = double(ggp/normterm);

%target: P-drop: BGG condition
eqTG = (1-(1-w0)*(1-w1)*(1-w2));
eq3 = eqSC*eqTG;
gg = int(int(int(int(eq3, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_gg = double(gg/normterm);

%target: G-drop: BGP condition
eqTG = (1-(1-w0)*(1-w1))*(1-w3);
eq4 = eqSC*eqTG;
gp = int(int(int(int(eq4, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_gp = double(gp/normterm);

%target: BG
eqTG = (1-(1-w0)*(1-w1));
eq5 = eqSC*eqTG;
g = int(int(int(int(eq5, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_g = double(g/normterm);

%target: BP
eqTG = w0*(1-w3);
eq6 = eqSC*eqTG;
p = int(int(int(int(eq6, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_p = double(p/normterm);

% print out the model predictions for each argument type
fprintf('\n**Model predictions for predictive/positive inference**\n');
fprintf('predictive/positive inference for GGP: %.4f\n', subs(prob_ggp));
fprintf('predictive/positive inference for GG: %.4f\n', subs(prob_gg));
fprintf('predictive/positive inference for GP: %.4f\n', subs(prob_gp));





