% Experiment 2: Causal attribution
% how likely it was G1 occurred and produced the effect 
% Background cause: B
% Generative cause 1: G1
% Generative cause 2: G2
% Preventive cause 1: P1
% feature counting for calculating baserate of G1
% use sequetial prevention equation 
% last update on 6/1/10 by HeeSeung


clear all;
syms w0 w1 w2 w3;


%When a source has B(w0), G1(w1), G2(w2), and P1(w3)
%normalizing term
eqS = (1-(1-w0)*(1-w1)*(1-w2))*(1-w3); % Source
normterm = int(int(int(int(eqS, w0,0,1), w1,0,1),w2,0,1),w3,0,1);

%target: No-drop:GPE condition %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%G1
eq = w1*eqS;
g1 = int(int(int(int(eq, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_g1 = g1/normterm;

%G1BG2P: noisy_or(G1, BG2P)
eqTbg2p = (1-(1-w0)*(1-w2))*(1-w3);
eqT = 1-(1-w1)*(1-eqTbg2p); %noisy-or(G1, BG2P)
eq2 = eqS*eqT;
g1g2p = int(int(int(int(eq2, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bg1g2p = g1g2p/normterm;

%BG2P
eq4 = eqTbg2p*eqS;
bg2p = int(int(int(int(eq4, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bg2p = bg2p/normterm;

prob_gpe = double(prob_g1*(6/7)/(prob_bg1g2p*(6/7)+prob_bg2p*(1/7)));

%target: P-drop: GE condition %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%G1BG2: noisy_or(G1, BG2)
eqT = 1-(1-w0)*(1-w1)*(1-w2);
eq3 = eqS*eqT;
gg = int(int(int(int(eq3, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bg1g2 = gg/normterm;

%BG2: 
eq5 = (1-(1-w0)*(1-w2))*eqS;
g2 = int(int(int(int(eq5, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bg2 = g2/normterm;

prob_ge = double(prob_g1*(30/42)/(prob_bg1g2*(30/42)+prob_bg2*(12/42)));


%target: G-drop: PE condition %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%G1BP: noisy_or(G1, BP)
eqTbp = w0*(1-w3);
eqT = 1-(1-w1)*(1-eqTbp);
eq4 = eqS*eqT;
bg1p = int(int(int(int(eq4, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bg1p = bg1p/normterm;

%BP
eq6 = eqTbp*eqS;
p = int(int(int(int(eq6, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bp = p/normterm;

prob_pe = double(prob_g1*(30/42)/(prob_bg1p*30/42+prob_bp*12/42));

% print out the model predictions for each argument type
fprintf('\n**Model predictions for causal attribution**\n');
fprintf('causal attribution for GPE: %.4f\n', subs(prob_gpe));
fprintf('causal attribution for GE: %.4f\n', subs(prob_ge));
fprintf('causal attribution for PE: %.4f\n', subs(prob_pe));



