% Experiment 3
% Causal attribution
% Cross domain materials
% No transfer from the source
% 6/3/2010 by Hee Seung Lee

%% Subgroup1
% Correct causal attribution 

clear all;
syms w0 w1 w2 w3;

% Predictive Inference 
% When a source has B(w0), G1(w1), G2(w2), and P1(w3)

% No transfer from the source
%normalizing term
%eqS = (1-(1-w0)*(1-w1)*(1-w2))*(1-w3); % Source
%normterm = int(int(int(int(eqS, w0,0,1), w1,0,1),w2,0,1),w3,0,1);

%target: No-drop: GPE condition %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%G1
eq = w1;
g1 = int(int(int(int(eq, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_g1 = g1;

%G1BG2P: noisy_or(G1, BG2P)
eqTbg2p = (1-(1-w0)*(1-w2))*(1-w3);
eqT = 1-(1-w1)*(1-eqTbg2p); %noisy-or(G1, BG2P)
eq2 = eqT;
g1g2p = int(int(int(int(eq2, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bg1g2p = g1g2p;

%BG2P
eq4 = eqTbg2p;
bg2p = int(int(int(int(eq4, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bg2p = bg2p;

prob_gpe = double(prob_g1*(6/7)/(prob_bg1g2p*(6/7)+prob_bg2p*(1/7)));

%target: P-drop: GE condition  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%G1BG2: noisy_or(G1, BG2)
eqT = 1-(1-w0)*(1-w1)*(1-w2);
eq3 = eqT;
gg = int(int(int(int(eq3, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bg1g2 = gg;

%BG2: 
eq5 = (1-(1-w0)*(1-w2));
g2 = int(int(int(int(eq5, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bg2 = g2;

prob_ge = double(prob_g1*(30/42)/(prob_bg1g2*(30/42)+prob_bg2*(12/42)));


%target: G-drop: PE condition %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%G1BP: noisy_or(G1, BP)
eqTbp = w0*(1-w3);
eqT = 1-(1-w1)*(1-eqTbp);
eq4 = eqT;
bg1p = int(int(int(int(eq4, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bg1p = bg1p;

%BP
eq6 = eqTbp;
p = int(int(int(int(eq6, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_bp = p;

prob_pe = double(prob_g1*(30/42)/(prob_bg1p*30/42+prob_bp*12/42));


% print out the model predictions for each argument type
fprintf('\n**Expt3-Subgroup 1**\n');
fprintf('causal attribution for No-drop/GPE condition: %.4f\n', subs(prob_gpe));
fprintf('causal attribution for P-drop/GE condition: %.4f\n', subs(prob_ge));
fprintf('causal attribution for G-drop/PE condition: %.4f\n', subs(prob_pe));

%% Subgroup2
% treat causal attribution as predictive inference
% GPE = GGP
% GE = GG
% PE = GP

clear all;
syms w0 w1 w2 w3;

% Predictive Inference 
% When a source has B(w0), G1(w1), G2(w2), and P1(w3)

%No transfer from the source
%normalizing term in the source BGGP
%eqSC = (1-(1-w0)*(1-w1)*(1-w2))*(1-w3);
%normterm = int(int(int(int(eqSC, w0,0,1), w1,0,1),w2,0,1),w3,0,1);

%target: GPE condition = BGGP
eqTG = (1-(1-w0)*(1-w1)*(1-w2))*(1-w3);
eq2 = eqTG;
ggp = int(int(int(int(eq2, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_ggp = double(ggp);

%target: GE condition = BGG
eqTG = (1-(1-w0)*(1-w1)*(1-w2));
eq3 = eqTG;
gg = int(int(int(int(eq3, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_gg = double(gg);

%target: PE condition = BGP
eqTG = (1-(1-w0)*(1-w1))*(1-w3);
eq4 = eqTG;
gp = int(int(int(int(eq4, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_gp = double(gp);

%target: BG
eqTG = (1-(1-w0)*(1-w1));
eq5 = eqTG;
g = int(int(int(int(eq5, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_g = double(g);

%target: BP
eqTG = w0*(1-w3);
eq6 = eqTG;
p = int(int(int(int(eq6, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_p = double(p);

% print out the model predictions for each argument type
fprintf('\n**Expt3-Subgroup 2**\n');
fprintf('causal attribution for No-drop/GPE condition: %.4f\n', subs(prob_ggp));
fprintf('causal attribution for P-drop/GE condition: %.4f\n', subs(prob_gg));
fprintf('causal attribution for G-drop/PE condition: %.4f\n', subs(prob_gp));