% Mapping ambiguity study modeling 
% Experiment 4

% Specific condition: P-absent(GG) and P-present(GGP)
% Generic condition: P-absent(XX) and P-present(XXP)
% 6/3/2010 by Hee Seung Lee

%%

clear all;
syms w0 w1 w2 w3 w4;

% Predictive Inference 
% When a source has Background cause B(w0), G1(w1), G2(w2), and P1(w3)
% P1 is a narrow preventer

% Nothing is transferred from the source
% normalizing term in the source BGGP
% source: BGGP: noisy-or (BG, GP)
%eqSCgp = (1-(1-w2))*(1-w3);
%eqSC = 1-(1-w0)*(1-w1)*(1-eqSCgp);
%normterm = int(int(int(int(eqSC, w0,0,1), w1,0,1),w2,0,1),w3,0,1);


%target: Specific, P-absent condtion: BGG
eqTG = 1-(1-w0)*(1-w1)*(1-w2);
eq1 = eqTG;
gg = int(int(int(int(eq1, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_gg = double(gg);

%target: Specific, P-present condition: BGGP: noisy-or(BG, GP)
eqTGgp = (1-(1-w2))*(1-w3);
eqTG = 1-(1-w0)*(1-w1)*(1-eqTGgp);
eq2 = eqTG;
ggp = int(int(int(int(eq2, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_ggp = double(ggp);

%target: B
eqTG = w0;
eq3 = eqTG;
b = int(int(int(int(eq3, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_b = double(b);

%target: BP = B (P doesn't prevent B)
eqTG = w0;
eq4 = eqTG;
p = int(int(int(int(eq4, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_p = double(p);

%target: BGP noisy-OR(B, GP)
eqTGgp = (1-(1-w2))*(1-w3);
eqTG = 1-(1-w0)*(1-eqTGgp);
eq5 = eqTG;
gp = int(int(int(int(eq5, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_gp = double(gp);

%target: BG
eqTG = 1-(1-w0)*(1-w1);
eq6 = eqTG;
g = int(int(int(int(eq6, w0,0,1), w1,0,1),w2,0,1),w3,0,1);
prob_g = double(g);

%target: Genric, P-absent condition: BXX
prob_xx = 1/2*(prob_gg);

%target: Generic, P-present condition: BXXP
prob_xxp = prob_ggp;


% print out the model predictions for each argument type
fprintf('\n**Experiment 4 model predictions**\n');
fprintf('Specific/P-absent condition(GG): %.4f\n', subs(prob_gg));
fprintf('Specific/P-present condition(GGP): %.4f\n', subs(prob_ggp));
fprintf('Generic/P-absent condition(XX): %.4f\n', subs(prob_xx));
fprintf('Generic/P-present condition(XXP): %.4f\n', subs(prob_xxp));

